.nr % 1
.OH ''PBS ERS'Appendix A'
.EH 'Appendix A'PBS ERS''
.P1
.so ers_setup.ms
.Rv $Revision: 2.1 $
.SH 1
Appendix A - Scheduler Language Syntax
.OF 'Chapt \*(rV''B-%'
.EF 'A-%''Chapt \*(rV'
.LP
.\"         Portable Batch System (PBS) Software License
.\" 
.\" Copyright (c) 1999, MRJ Technology Solutions.
.\" All rights reserved.
.\" 
.\" Acknowledgment: The Portable Batch System Software was originally developed
.\" as a joint project between the Numerical Aerospace Simulation (NAS) Systems
.\" Division of NASA Ames Research Center and the National Energy Research
.\" Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
.\" 
.\" Redistribution of the Portable Batch System Software and use in source
.\" and binary forms, with or without modification, are permitted provided
.\" that the following conditions are met:
.\" 
.\" - Redistributions of source code must retain the above copyright and
.\"   acknowledgment notices, this list of conditions and the following
.\"   disclaimer.
.\" 
.\" - Redistributions in binary form must reproduce the above copyright and 
.\"   acknowledgment notices, this list of conditions and the following
.\"   disclaimer in the documentation and/or other materials provided with the
.\"   distribution.
.\" 
.\" - All advertising materials mentioning features or use of this software must
.\"   display the following acknowledgment:
.\" 
.\"   This product includes software developed by NASA Ames Research Center,
.\"   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
.\" 
.\"         DISCLAIMER OF WARRANTY
.\" 
.\" THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" 
.\" WITHOUT WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, 
.\" INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, 
.\" FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY
.\" DISCLAIMED.
.\"
.\" IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
.\" THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
.\" NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\" 
.\" This license will be governed by the laws of the Commonwealth of Virginia,
.\" without reference to its choice of law rules.
.QP
Due to problems with the current implementation of the BASL Scheduler, it
is recommended that it not be used.  Instead used either the Tcl or C
based schedulers.
.QP
The following information is retained for information only.
.LP
The following is the syntax definition for the Batch Scheduler Language 
(BASL) used by the PL (procedural language) job scheduler program, see section 8.
.sp 2
.nf
.Ty
declaration_list::=   declaration
                    | declaration declaration_list

declaration::=   source type identifier ';' 
               | source type identifier '=' constant ';' 
               | source type identifier identifier ';'   
               | source type identifier identifier '=' constant ';' 
               | monitor

type::=    "resource"
        |  "attribute"
        |  "requirement"
        |  "variable"

source::=     "job"
            | "queue"
            | "host"
            | "global"

identifier::=   ALPHASTRING               
            | identifier ':' ALPHASTRING 

monitor::=      "rm" NUMBER ALPHASTRING

program::=   compound_statement
          |  program compound_statement

compound_statement::=  '{' statement_list '}'
                    | iteration

statement_list::=   statement                       
                  | statement statement_list        

statement::=   compound_statement
              | expression';'
              | if_clause

if_clause::=     "if" '(' value ')' statement
             |   "if" '(' value ')' statement "else" statement 

expression::=   assignment
              | action
              | "break"
              | "exit"
              | "continue"

action::= "run"
        | "run JOBID"
        | "run at HOSTID"
        | "run JOBID at HOSTID"
        | "run THISJ"      
        | "run" lvalue     
        | "delete"
        | "delete JOBID"     
        | "delete THISJ"
        | "delete" lvalue     
        | "delete" lvalue lvalue   
        | "delete JOBID" lvalue     
        | "delete THISJ" lvalue     
        | "rmquery"                 

assignment::=   lvalue ASSIGNOP value   
              | lvalue POSTOP  

ASSIGNOP::= "=" 
          | "+="
          | "-="
          | "*="
          | "/="

POSTOP::= "++"
        | "--"

iteration::=   "foreach job"   statement
             | "foreach queue" statement
             | "foreach host"  statement 

value::=    lvalue
         |  constant
         |  value LOGICAL value  
         |  value ARITHOP value  
         |  value COMPARATOR value
         |  '!'  value 
         |  expression 
         | '(' value ')' 

LOGICAL::= "||"
         | "&&"

ARITHOP::= "+"
         | "-"
         | "*" 
         | "/"
         | "^"

COMPARATOR::= "<"
            | ">" 
            | "==" 
            | "<="
            | ">="
            | "!="

lvalue::=   identifier   

constant::= NUMBER   
          | NUMBER SUFFIX 
          | time 
          | DAY
          | "THISJOB"
          | "THISQUEUE" 
          | "THISHOST" 
          | "JID" 
          | "QID"
          | "HID"
          | '"' identifier '"' 

DAY::=      mon 
          | tue 
          | wed
          | thu 
          | fri
          | sat
          | sun 
          | Mon
          | Tue
          | Wed 
          | Thu
          | Fri
          | Sat
          | Sun           


time::=     datecon   
          | intercon   
          | timecon    

datecon::=  NUMBER ',' NUMBER ',' NUMBER   

intercon::= INTERVAL              
          | intercon INTERVAL  
          
timecon::=  NUMBER ':' NUMBER ':' NUMBER   

SUFFIX::= "kw"
        | "Kw"
        | "KW"
        | "kb" 
        | "Kb"
        | "KB" 
        | "mw" 
        | "Mw" 
        | "MW" 
        | "mb" 
        | "Mb" 
        | "MB" 
        | "gw" 
        | "Gw" 
        | "GW"
        | "gb" 
        | "Gb" 
        | "GB"
.fi
.ft 1

