.\" 
.\"         Portable Batch System (PBS) Software License
.\" 
.\" Copyright (c) 1999, MRJ Technology Solutions.
.\" All rights reserved.
.\" 
.\" Acknowledgment: The Portable Batch System Software was originally developed
.\" as a joint project between the Numerical Aerospace Simulation (NAS) Systems
.\" Division of NASA Ames Research Center and the National Energy Research
.\" Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
.\" 
.\" Redistribution of the Portable Batch System Software and use in source
.\" and binary forms, with or without modification, are permitted provided
.\" that the following conditions are met:
.\" 
.\" - Redistributions of source code must retain the above copyright and
.\"   acknowledgment notices, this list of conditions and the following
.\"   disclaimer.
.\" 
.\" - Redistributions in binary form must reproduce the above copyright and 
.\"   acknowledgment notices, this list of conditions and the following
.\"   disclaimer in the documentation and/or other materials provided with the
.\"   distribution.
.\" 
.\" - All advertising materials mentioning features or use of this software must
.\"   display the following acknowledgment:
.\" 
.\"   This product includes software developed by NASA Ames Research Center,
.\"   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
.\" 
.\"         DISCLAIMER OF WARRANTY
.\" 
.\" THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" 
.\" WITHOUT WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, 
.\" INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, 
.\" FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY
.\" DISCLAIMED.
.\"
.\" IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
.\" THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
.\" NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\" 
.\" This license will be governed by the laws of the Commonwealth of Virginia,
.\" without reference to its choice of law rules.
.\" The following macros changes are to allow "man" pages
.\" to be included in this document formatted with -ms
.\" 
.\" The TH macro, used for headers on a man page, must be ignored (skipped
.\" over) when process the pages with -ms.
.\" The Sh is defined on each included "man" page to approximate
.\" what is output with the -man macro .SH as opposed to the -ms macro
.\" The setting of the register Pb to 1 triggers the -ms form of the Sh
.\" macro used in the man pages included in the ERS.  Otherwise, the Sh
.\" macro invokes the -man macro .SH.
.\" 
.nr Pb 1  \" turn on -ms version of macros for "man" pages.
.\" 
.de IR
.I \\$1 \\$2 \\$3 \\$4
..
.de BR
.B \\$1 \\$2 \\$3 \\$4
..
.\" include special ERS style macro definitions
.so ../ers/ers.macros
.\" following macro cuts the date provided by RCS so only yy/mm/dd shows
.de Cd
\&\\$2
..
.de Rv
.ds rV Revision: \\$2
..
.\" macro to use in generating TOC section, parameter is printed and output
.\" if number register I = 2, output in XA format for PS PE macros
.de Tc
\&\\$1 \\$2 \\$3 \\$4 \\$5
.if \\nI=2 \{\
.	tm .XA \\n(H1-\\n(PN
.	tm \\*(SN \\$1 \\$2 \\$3 \\$4 \\$5
.\}
..

