.nr % 1
.OH ''PBS ERS'Operator Commands'
.EH 'Operator Commands'PBS ERS''
.P1
.so ers_setup.ms
.Rv $Revision: 2.1 $
.nr H1 5
.NH 1
.Tc \f3\s+2Operator Commands\s-2\fP
.OF 'Chapt \*(rV''\n(H1-%'
.EF '\n(H1-%''Chapt \*(rV'
.\"         Portable Batch System (PBS) Software License
.\" 
.\" Copyright (c) 1999, MRJ Technology Solutions.
.\" All rights reserved.
.\" 
.\" Acknowledgment: The Portable Batch System Software was originally developed
.\" as a joint project between the Numerical Aerospace Simulation (NAS) Systems
.\" Division of NASA Ames Research Center and the National Energy Research
.\" Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
.\" 
.\" Redistribution of the Portable Batch System Software and use in source
.\" and binary forms, with or without modification, are permitted provided
.\" that the following conditions are met:
.\" 
.\" - Redistributions of source code must retain the above copyright and
.\"   acknowledgment notices, this list of conditions and the following
.\"   disclaimer.
.\" 
.\" - Redistributions in binary form must reproduce the above copyright and 
.\"   acknowledgment notices, this list of conditions and the following
.\"   disclaimer in the documentation and/or other materials provided with the
.\"   distribution.
.\" 
.\" - All advertising materials mentioning features or use of this software must
.\"   display the following acknowledgment:
.\" 
.\"   This product includes software developed by NASA Ames Research Center,
.\"   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
.\" 
.\"         DISCLAIMER OF WARRANTY
.\" 
.\" THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" 
.\" WITHOUT WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, 
.\" INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, 
.\" FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY
.\" DISCLAIMED.
.\"
.\" IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
.\" THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
.\" NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\" 
.\" This license will be governed by the laws of the Commonwealth of Virginia,
.\" without reference to its choice of law rules.
.LP
A batch operator is a user of the system who is granted privilege to
perform actions beyond those available to the normal user.  Typical
of those actions are starting and stopping of individual queues and
the server itself, and modification or deleting the jobs of other users.
.LP
The operator will be able to use the following general user commands
with increased privilege: qalter, qdel, qhold, qmove, qmsg, qrerun,
qrls, qsig, and qstat.
Additionally, the operator will have access to the new commands described in
this section: qdisable, qenable, qrun, qstart, qstop, qterm, pbs_mom,
pbs_sched, pbs_server, and pbsnodes.
.bp
.NH 2
.Tc "\f3Initiate Server Operation\fP"
.LP
.so ../man8/pbs_server.8B
.bp
.NH 2
.Tc "\f3Initiate Execution Mini-server (MOM) Operation\fP"
.LP
.so ../man8/pbs_mom.8B
.bp
.NH 2
.Tc \f3Disable Queue\fP
.LP
.so ../man8/qdisable.8B
.bp
.NH 2
.Tc \f3Enable Queue\fP
.LP
.so ../man8/qenable.8B
.bp
.NH 2
.Tc \f3Run Job\fP
.LP
.so ../man8/qrun.8B
.bp
.NH 2
.Tc \f3Start Queue\fP
.LP
.so ../man8/qstart.8B
.bp
.NH 2
.Tc \f3Stop Queue\fP
.LP
.so ../man8/qstop.8B
.bp
.NH 2
.Tc "\f3Terminate Server Operation\fP"
.LP
.so ../man8/qterm.8B
.bp
\&
.if o \{
\&
.bp
\}
.OH ''PBS ERS' Administrator Commands'
.EH 'Administrator Commands'PBS ERS''
.pn 1
.bp
.NH 1
.Tc \f3\s+2Administrator Commands\s-2\fP
.OF 'Chapt \*(rV''\n(H1-%'
.EF '\n(H1-%''Chapt \*(rV'
.LP
A batch administrator is a user of the system who is granted the highest
level of privilege in the batch system.  The batch administrator is able
to perform all operator functions and additionally modify queue and
server configurations.
.LP
In addition to the general user commands available to an operator with
increased privilege and the special operator commands, the administrator
has access to the 
.B qmgr
command.
Information on the Resource Monitor and Schedulers are also provided for the
administrator.
.LP
There are three different schedulers provided with PBS.  The yacc/lex based
scheduler is driven by a procedure written in a \*QC - like language.\*U
This BAtch Scheduler Language (BASL) scheduler is sometimes referred
to (incorrectly) as the \*Qrules\*U based scheduler.
.LP
Another scheduler based on Tcl\**
.FS
Tool Control Langague - see \*QTcl and the Tk Toolkit\*U by John K. Ousterhout.
.FE
another is a C language framework.
is provided for sites which wish a different approach.
The third scheduler is a framework (main program) written in the C language.
The site must supply the primary function (in C) which implements the scheduling
policy.
.bp
.NH 2
.Tc "\f3PBS Job Schedulers\fP"
.LP
.NH 3
C Based Job Scheduler
.LP
.so ../man8/pbs_sched_cc.8B
.bp
.NH 3
Yacc/lex Based Job Scheduler
.LP
.so ../man8/pbs_sched_basl.8B
.bp
.NH 3
Tcl Based Job Scheduler
.LP
.so ../man8/pbs_sched_tcl.8B
.bp
.NH 2
.Tc "\f3Node Management\fP"
.LP
.so ../man8/pbsnodes.8B
.bp
.NH 2
.Tc "\f3Manage Server\fP"
.LP
.so ../man8/qmgr.8B
.\" force next chapter to odd page
.bp
.if e \{
\&
.sp 10
.DS C
[Page intentionally left bank.]
.DE
.bp
\}
