.\"         Portable Batch System (PBS) Software License
.\" 
.\" Copyright (c) 1999, MRJ Technology Solutions.
.\" All rights reserved.
.\" 
.\" Acknowledgment: The Portable Batch System Software was originally developed
.\" as a joint project between the Numerical Aerospace Simulation (NAS) Systems
.\" Division of NASA Ames Research Center and the National Energy Research
.\" Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
.\" 
.\" Redistribution of the Portable Batch System Software and use in source
.\" and binary forms, with or without modification, are permitted provided
.\" that the following conditions are met:
.\" 
.\" - Redistributions of source code must retain the above copyright and
.\"   acknowledgment notices, this list of conditions and the following
.\"   disclaimer.
.\" 
.\" - Redistributions in binary form must reproduce the above copyright and 
.\"   acknowledgment notices, this list of conditions and the following
.\"   disclaimer in the documentation and/or other materials provided with the
.\"   distribution.
.\" 
.\" - All advertising materials mentioning features or use of this software must
.\"   display the following acknowledgment:
.\" 
.\"   This product includes software developed by NASA Ames Research Center,
.\"   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
.\" 
.\"         DISCLAIMER OF WARRANTY
.\" 
.\" THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" 
.\" WITHOUT WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, 
.\" INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, 
.\" FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY
.\" DISCLAIMED.
.\"
.\" IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
.\" THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
.\" NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\" 
.\" This license will be governed by the laws of the Commonwealth of Virginia,
.\" without reference to its choice of law rules.
.\" include special ERS/IDS style macro definitions
.\" The following macros are style for object names and values.
.de Ar		\" command/function arguments and operands (italic)
.ft 2
.if \\n(.$>0 \&\\$1\fP\\$2
..
.de Av		\" data item values  (Helv)
.ft 6
.ps -1
.if \\n(.$>0 \&\\$1\s+1\fP\\$2
..
.de At		\" attribute and data item names (Helv Bold)
.ft 6
.ps -1
.if \\n(.$>0 \&\\$1\s+1\fP\\$2
..
.de Ty		\" Type-ins and examples (typewritter)
.ft 5
.if \\n(.$>0 \&\\$1\fP\\$2
..
.de Er		\" Error values ( [Helv] )
\&\f6\s-1[\^\\$1\^]\s+1\fP\\$2
..
.de Sc		\" Symbolic constants ( {Helv} )
\&\f6\s-2{\^\\$1\^}\s+2\fP\\$2
..
.de Al		\" Attribute list item, like .IP but set font and size
.IP "\&\f6\s-1\\$1\s+1\fP"
..
.\" following macro cuts the date provided by RCS so only yy/mm/dd shows
.de Cd
\&\\$2
..
.de Rv
.ds rV Draft Revision: \\$2
..
.\" the following pair of macros are used to bracket sections of code
.de Cs
.ft 5
.nf
..
.de Ce
.sp
.fi
.ft 1
..
.\" the following macro is used to place a box around a function name
.\" at the start of the functions description, this highlights it.
.\" it will also create an index entry if number register is set to 1.
.de Fn
.sp
.B1
.sp
\&\\$1
.if \\nI=1 .tm \\$1 | \\n(H1-\\n(PN
.sp
.B2
.sp
..
.\" the following macro is used to create a TOC (I=2) or index (I=1) entry 
.\" for a module (file) name
.de Fi
File: \\$1
.if \\nI=1 .tm \\$1 | \\n(H1-\\n(PN
.if \\nI=2 \{\
.	tm .XA \\n(H1-\\n(PN
.	tm \\*(SN \\$1
.\}
..
.\" macro to use in generating TOC section, parameter is printed and output
.\" if number register I = 2, output in XA format for PS PE macros
.de Tc
\&\\$1 \\$2 \\$3 \\$4 \\$5
.if \\nI=2 \{\
.	tm .XA \\n(H1-\\n(PN
.	tm \\*(SN \\$1 \\$2 \\$3 \\$4 \\$5
.\}
..
.\" macro to use in generating Index entries
.de Ix
\&\\$1
.if \\nI=1 .tm \\$1 | \\n(H1-\\n(PN
..
.\" End of macros 
