/*
*         Portable Batch System (PBS) Software License
* 
* Copyright (c) 1999, MRJ Technology Solutions.
* All rights reserved.
* 
* Acknowledgment: The Portable Batch System Software was originally developed
* as a joint project between the Numerical Aerospace Simulation (NAS) Systems
* Division of NASA Ames Research Center and the National Energy Research
* Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
* 
* Redistribution of the Portable Batch System Software and use in source
* and binary forms, with or without modification, are permitted provided
* that the following conditions are met:
* 
* - Redistributions of source code must retain the above copyright and
*   acknowledgment notices, this list of conditions and the following
*   disclaimer.
* 
* - Redistributions in binary form must reproduce the above copyright and 
*   acknowledgment notices, this list of conditions and the following
*   disclaimer in the documentation and/or other materials provided with the
*   distribution.
* 
* - All advertising materials mentioning features or use of this software must
*   display the following acknowledgment:
* 
*   This product includes software developed by NASA Ames Research Center,
*   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
* 
*         DISCLAIMER OF WARRANTY
* 
* THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
* WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
* BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
* FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
* 
* IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
* THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
* NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
* OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
* OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
* USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
* 
* This license will be governed by the laws of the Commonwealth of Virginia,
* without reference to its choice of law rules.
*/

/*
 * @(#) $Id: svrfunc.h,v 2.3 1999/07/21 22:56:42 lonhyn Exp $
 */

/*
 * misc server function prototypes
 */

extern int   chk_hold_priv A_((long hold, int priv));
extern void  get_jobowner A_((char *from, char *to));
extern char *parse_servername A_((char *, unsigned int *));
extern void  process_Areply A_((int));
extern void  process_Dreply A_((int));
extern void  process_request A_((int));
extern void  process_dis_request A_((int));
extern int   save_flush();
extern void  save_setup A_((int));
extern int   save_struct A_((char *, unsigned int));
extern void  schedule_job A_((void));
extern char *site_map_user A_((char *, char *));
extern int   socket_to_handle A_((int));
extern void  svr_disconnect A_((int));
extern int   svr_get_privilege A_((char *, char *));
extern int   srv_shutdown A_((int));
extern void  write_node_state A_((void ));
extern int   setup_nodes A_((void));
extern int   node_avail A_((char *spec, int  *navail,
			    int *nalloc, int *nreserved, int *ndown));
extern void  node_unreserve A_((resource_t handle));
extern int   node_reserve A_((char *speclist, resource_t tag));

#ifdef JOB_H
extern int   set_nodes A_((job *pjob, char *spec, char	**rtnlist));
extern int   is_ts_node A_((char * nodestr));
extern char *find_ts_node A_((void));
extern void  free_nodes A_((job *));
#endif	/* JOB_H */

#ifdef ATTRIBUTE_H
extern int   check_que_enable A_((attribute *, void *, int));
extern int   set_queue_type A_((attribute *, void *, int));
#ifdef QUEUE_H
extern int   chk_resc_limits A_((attribute *, pbs_queue *));
#endif	/* QUEUE_H */
#endif	/* ATTRIBUTE_H */

#ifdef PBS_NET_H
extern int   svr_connect A_((pbs_net_t, unsigned int, void (*)(int), enum conn_type));
#endif	/* PBS_NET_H */

#ifdef WORK_TASK_H
extern void  release_req A_((struct work_task *));
#ifdef BATCH_REQUEST_H
extern int   issue_Drequest A_((int, struct batch_request *, void (*)(), struct work_task **));
#endif	/* BATCH_REQUEST_H */
#endif	/* WORK_TASK_H */


/* The following is used in req_stat.c and req_select.c */

#ifdef STAT_CNTL

struct select_list {
	struct select_list *sl_next;	/* ptr to next in list   */
	enum batch_op	    sl_op;	/* comparison operator   */
	attribute_def      *sl_def;	/* ptr to attr definition,for at_comp */
	int		    sl_atindx;	/* index into attribute_def, for type */
	attribute	    sl_attr;	/* the attribute (value) */
};

struct stat_cntl {		/* used in req_stat_job */
	int		      sc_XXXX;
	int		      sc_type;
	int		      sc_XXXY;
	int		      sc_conn;
	pbs_queue	     *sc_pque;
	struct batch_request *sc_origrq;
	struct select_list   *sc_select;
	void		    (*sc_post) A_((struct stat_cntl *));
	char		      sc_jobid[PBS_MAXSVRJOBID+1];
};

extern int stat_to_mom A_((job *, struct stat_cntl *));

#endif	/* STAT_CNTL */
