/*
*         Portable Batch System (PBS) Software License
* 
* Copyright (c) 1999, MRJ Technology Solutions.
* All rights reserved.
* 
* Acknowledgment: The Portable Batch System Software was originally developed
* as a joint project between the Numerical Aerospace Simulation (NAS) Systems
* Division of NASA Ames Research Center and the National Energy Research
* Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
* 
* Redistribution of the Portable Batch System Software and use in source
* and binary forms, with or without modification, are permitted provided
* that the following conditions are met:
* 
* - Redistributions of source code must retain the above copyright and
*   acknowledgment notices, this list of conditions and the following
*   disclaimer.
* 
* - Redistributions in binary form must reproduce the above copyright and 
*   acknowledgment notices, this list of conditions and the following
*   disclaimer in the documentation and/or other materials provided with the
*   distribution.
* 
* - All advertising materials mentioning features or use of this software must
*   display the following acknowledgment:
* 
*   This product includes software developed by NASA Ames Research Center,
*   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
* 
*         DISCLAIMER OF WARRANTY
* 
* THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
* WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
* BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
* FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
* 
* IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
* THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
* NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
* OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
* OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
* USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
* 
* This license will be governed by the laws of the Commonwealth of Virginia,
* without reference to its choice of law rules.
*/
/*************************************************************
*      myname           SymTabGlob.h
*      created          7/14/1996
*      updated          8/13/1996
*      works            8/13/1996
*
*************************************************************/

/* NOTE: If you must modify this, be sure to update the */
/*       ordering so that they are all sequential relative */
/* 	 to their array index position. For example, if you */
/*       remove "QUETYPE 7", then slot 7 must be reassigned */
/*	 to the next type so that will have "JOBTYPE 7", */
/*	 "SIZETYPE 8", and so on. */
char * SymTypes[] =
{
        "UNKNOWN 0",
        "INTTYPE 1",
        "FLOATTYPE 2",
        "STRINGTYPE 3",
        "STATUSTYPE 4",
        "DAYOFWEEKTYPE 5",
        "SERVERTYPE 6",
        "QUETYPE 7",
        "JOBTYPE 8",
        "SIZETYPE 9",
        "INTRANGETYPE 10",
        "FLOATRANGETYPE 11",
        "DAYOFWEEKRANGETYPE 12",
        "SERVERSETTYPE 13",
        "QUESETTYPE 14",
        "JOBSETTYPE 15",
        "SIZESETTYPE 16",
        "PARAMTYPE 17",
        "FUNTYPE 18",
        "SERVERSTATETYPE 19",
        "QUESTATETYPE 20",
        "JOBSTATETYPE 21",
        "SIZESTATETYPE 22",
        "DATETYPE 23",
        "CNODETYPE 24",
        "VOIDTYPE 25",
        "DATETIMERANGETYPE 26",
        "CNODESETTYPE 27",
        "SIZERANGETTYPE 28",
	"GENERICTYPE 29",
	"KEYWORDTYPE 30",
        ""
};
