/*
*         Portable Batch System (PBS) Software License
* 
* Copyright (c) 1999, MRJ Technology Solutions.
* All rights reserved.
* 
* Acknowledgment: The Portable Batch System Software was originally developed
* as a joint project between the Numerical Aerospace Simulation (NAS) Systems
* Division of NASA Ames Research Center and the National Energy Research
* Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
* 
* Redistribution of the Portable Batch System Software and use in source
* and binary forms, with or without modification, are permitted provided
* that the following conditions are met:
* 
* - Redistributions of source code must retain the above copyright and
*   acknowledgment notices, this list of conditions and the following
*   disclaimer.
* 
* - Redistributions in binary form must reproduce the above copyright and 
*   acknowledgment notices, this list of conditions and the following
*   disclaimer in the documentation and/or other materials provided with the
*   distribution.
* 
* - All advertising materials mentioning features or use of this software must
*   display the following acknowledgment:
* 
*   This product includes software developed by NASA Ames Research Center,
*   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
* 
*         DISCLAIMER OF WARRANTY
* 
* THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
* WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
* BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
* FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
* 
* IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
* THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
* NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
* OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
* OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
* USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
* 
* This license will be governed by the laws of the Commonwealth of Virginia,
* without reference to its choice of law rules.
*/
/* USMID %Z%%M%	%I%	%G% %U% */

/*
 * Complex list head
 */
struct	qcomplex *Chead = (struct qcomplex *)0L;

/*
 *  Queue list head
 */
struct	qlist *Qhead = (struct qlist *)0L;

/*
 *  Route queue list head
 */
struct	routeq *Rhead = (struct routeq *)0L;

/*
 *  Production queue list
 */
struct pqueues *Phead = (struct pqueues *)0L;

/*
 *  Starvation assist structure
 */
struct	assist Assist;
struct	strvent *Starvlist = (struct strvent *)0L;
struct	qthresh *Thresholds = (struct qthresh *)0L;

#ifndef MAX_GROUP
#define MAX_GROUP 250
#endif
/*
struct alloc_group {
	char    gid[MAX_GROUP_NAME_SIZE];
	double  total_usage;
	double  allocation;
};
*/

/*
struct alloc_group group_table[MAX_GROUP];
*/

/*
 * Scheduler configuration parameters
 */
int		PNP			= 0;
int		DFR_IDLE		= 0;
int		DFR_IDLE_PRIME 		= 0;
int		DFR_IDLE_NONPRIME	= 0;
int		HIGH_SWAPRATE 		= 0;
int		MAX_LOADAVG 		= 0;
int		MIN_LOADAVG 		= 0;
int		NOM_LOADAVG 		= 0;
int		HIGH_SYSTIME 		= 0;
int		MAX_JOBS 		= 0;
int		MIN_JOBS 		= 0;
long long	LARGE_MEM		= 0L;
long long	LARGE_MEM_PRIME 	= 0L;
long long	LARGE_MEM_NONPRIME 	= 0L;
int		LARGE_CNT		= 0;
int		LARGE_CNT_PRIME 	= 0;
int		LARGE_CNT_NONPRIME 	= 0;
long long	LARGE_ALLOC		= 0L;
long long	LARGE_ALLOC_PRIME	= 0L;
long long	LARGE_ALLOC_NONPRIME	= 0L;
int		LONG_TIME 		= 0;
int		LONG_CNT 		= 0;
long long	BATCH_MEM 		= 0L;
int		STARVATION_TIMEOUT	= 0;
int		MAX_DED_JOBS		= 0;
char		*SERVER_HOST		= NULL;
char		*SCHED_HOST		= NULL;
int		DFR_QUEUE		= 0;
int		LINEAR_USAGE		= 0;
int		LARGE_CNT_LIM		= 0;
long long	LARGE_MEM_LIM		= 0L;
int		SCHED_ITERATION		= 60;
int		ENFORCE_ALLOC		= 0;
int 		ENFORCE_DEDTIME		= 0;
char		*SCHED_ACCT_DIR		= NULL;
char		*DED_TIME_COMMAND	= NULL;
char		*SYSTEM_NAME		= NULL;
char		*SYSTEM_NAME_CAPS	= NULL;

#ifndef MAXTXT
#define MAXTXT 127
#endif

/*
 * Misc Other Global Variables - JJPJ
 */
int 	need_to_get_alloc_info 		= 0;
int 	need_to_get_YTD_info 		= 0;
long 	got_alloc_info			= 0L;
long 	got_YTD_info			= 0L;
int 	n_Allocation			= 0;
int 	have_dedicated_time		= 0;
int 	Start_of_Dedicated_Time		= 0;
char 	Ded_Start_Date[MAXTXT+1];
char 	Ded_Start_Time[MAXTXT+1];
int 	End_of_Dedicated_Time		= 0;
char 	Ded_End_Date[MAXTXT+1];
char 	Ded_End_Time[MAXTXT+1];
time_t 	time_now;
time_t 	time_chk;
struct 	tm tm_now;
