/*
*         Portable Batch System (PBS) Software License
* 
* Copyright (c) 1999, MRJ Technology Solutions.
* All rights reserved.
* 
* Acknowledgment: The Portable Batch System Software was originally developed
* as a joint project between the Numerical Aerospace Simulation (NAS) Systems
* Division of NASA Ames Research Center and the National Energy Research
* Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
* 
* Redistribution of the Portable Batch System Software and use in source
* and binary forms, with or without modification, are permitted provided
* that the following conditions are met:
* 
* - Redistributions of source code must retain the above copyright and
*   acknowledgment notices, this list of conditions and the following
*   disclaimer.
* 
* - Redistributions in binary form must reproduce the above copyright and 
*   acknowledgment notices, this list of conditions and the following
*   disclaimer in the documentation and/or other materials provided with the
*   distribution.
* 
* - All advertising materials mentioning features or use of this software must
*   display the following acknowledgment:
* 
*   This product includes software developed by NASA Ames Research Center,
*   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
* 
*         DISCLAIMER OF WARRANTY
* 
* THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
* WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
* BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
* FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
* 
* IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
* THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
* NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
* OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
* OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
* USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
* 
* This license will be governed by the laws of the Commonwealth of Virginia,
* without reference to its choice of law rules.
*/
/* USMID %Z%%M%	%I%	%G% %U% */

/*
 * Complex list head
 */
extern	struct qcomplex *Chead;

/*
 *  Queue list head
 */
extern	struct qlist *Qhead;

/*
 *  Route queue list head
 */
extern	struct routeq *Rhead;

/*
 *  Production queue list
 */
extern	struct	pqueues *Phead;

/*
 *  Starvation assist structure
 */
extern	struct assist Assist;
extern	struct strvent *Starvlist;
extern	struct qthresh *Thresholds;

extern	struct alloc_group group_table[];

/*
 * Scheduler Configuration Parameters
 */
extern	int 	PNP;
extern	int 	DFR_IDLE;
extern	int 	DFR_IDLE_PRIME;
extern	int 	DFR_IDLE_NONPRIME;
extern	int 	HIGH_SWAPRATE;
extern	int 	MAX_LOADAVG;
extern	int 	MIN_LOADAVG;
extern	int 	NOM_LOADAVG;
extern	int 	HIGH_SYSTIME;
extern	int 	MAX_JOBS;
extern	int 	MIN_JOBS;
extern	long long LARGE_MEM;
extern	long long LARGE_MEM_PRIME;
extern	long long LARGE_MEM_NONPRIME;
extern	long long LARGE_ALLOC;
extern	long long LARGE_ALLOC_PRIME;
extern	long long LARGE_ALLOC_NONPRIME;
extern	long long BATCH_MEM;
extern	long long LARGE_MEM_LIM;
extern	int 	LARGE_CNT;
extern	int 	LARGE_CNT_PRIME;
extern	int 	LARGE_CNT_NONPRIME;
extern	int 	LONG_TIME;
extern	int 	LONG_CNT;
extern	int 	STARVATION_TIMEOUT;
extern	int 	MAX_DED_JOBS;
extern	char 	*SERVER_HOST;
extern  char 	*SCHED_HOST;
extern	int 	DFR_QUEUE;
extern	int 	LINEAR_USAGE;
extern	int 	LARGE_CNT_LIM;
extern	int 	SCHED_ITERATION;
extern  int 	ENFORCE_ALLOC;
extern	int 	ENFORCE_DEDTIME;
extern	char 	*SCHED_ACCT_DIR;
extern	char 	*DED_TIME_COMMAND;
extern	char 	*SYSTEM_NAME;
extern	char 	*SYSTEM_NAME_CAPS;

#ifndef MAXTXT
#define MAXTXT 127
#endif

#include <time.h>

/*
 * Misc Other Global Variables - JJPJ
 */
extern int 	need_to_get_alloc_info;
extern int 	need_to_get_YTD_info;
extern long 	got_alloc_info;
extern long 	got_YTD_info;
extern int 	n_Allocation;
extern int 	have_dedicated_time;
extern int 	Start_of_Dedicated_Time;
extern char 	Ded_Start_Date[MAXTXT+1];
extern char 	Ded_Start_Time[MAXTXT+1];
extern int 	End_of_Dedicated_Time;
extern char 	Ded_End_Date[MAXTXT+1];
extern char 	Ded_End_Time[MAXTXT+1];
extern time_t time_now;
extern time_t time_chk;
extern struct tm tm_now;
