/*
*         Portable Batch System (PBS) Software License
* 
* Copyright (c) 1999, MRJ Technology Solutions.
* All rights reserved.
* 
* Acknowledgment: The Portable Batch System Software was originally developed
* as a joint project between the Numerical Aerospace Simulation (NAS) Systems
* Division of NASA Ames Research Center and the National Energy Research
* Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
* 
* Redistribution of the Portable Batch System Software and use in source
* and binary forms, with or without modification, are permitted provided
* that the following conditions are met:
* 
* - Redistributions of source code must retain the above copyright and
*   acknowledgment notices, this list of conditions and the following
*   disclaimer.
* 
* - Redistributions in binary form must reproduce the above copyright and 
*   acknowledgment notices, this list of conditions and the following
*   disclaimer in the documentation and/or other materials provided with the
*   distribution.
* 
* - All advertising materials mentioning features or use of this software must
*   display the following acknowledgment:
* 
*   This product includes software developed by NASA Ames Research Center,
*   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
* 
*         DISCLAIMER OF WARRANTY
* 
* THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
* WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
* BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
* FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
* 
* IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
* THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
* NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
* OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
* OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
* USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
* 
* This license will be governed by the laws of the Commonwealth of Virginia,
* without reference to its choice of law rules.
*/
/* $Id: msgs.h,v 1.1 1999/04/16 19:33:23 hender Exp $ */

#ifndef MSGS_H_
#define MSGS_H_

/*
 * These symbolic constants are used to reference the individual strings
 * in 'msgs.c'.  Be sure to update the strings in 'msgs.c' to reflect any
 * changes made to these constants.
 */

extern char *schd_JobMsg[];	/* from 'msgs.c' */

#define	NO_FREE_MEM		0	/* Unused */
#define NO_NODES		1
#define HIGH_LOAD		2	/* Unused */
#define WAIT_FOR_DEDTIME	3
#define IN_DED_TIME		4
#define NO_DED_TIME		5
#define NOT_PRIME_TIME		6	/* Unused */
#define IN_PRIMETIME		7	/* Unused */
#define NO_INTER_JOBS		8	/* Unused */
#define NO_BATCH_JOBS		9	/* Unused */
#define WAIT_FOR_BIG_JOB	10	/* Unused */
#define RUNNING_BIG_JOB		11	/* Unused */
#define OVERLAP_BATCH		12	/* Unused */
#define OVERLAP_PRIME		13	/* Unused */
#define	NO_RESOURCES		14
#define	JOB_RESTARTED		15
#define	JOB_RESUBMITTED		16

#endif /* ! MSGS_H_ */
